#ifndef __PIC32_USB_C
#define __PIC32_USB_C

// Includes -----------------------------------------------------------------------------------------------------------

#include <xc.h>

#include "HardwareProfile.h"
#include "usb_cdc.h"
#include "usb_hid.h"

#include "USB/usb_function_hid.h"
#include "USB/usb_function_cdc.h"

// Function Declarations ----------------------------------------------------------------------------------------------

static void ProcessIO(void);
void UpdateStatusDisplay(void);

// Function Definitions -----------------------------------------------------------------------------------------------

/**
 * Main application entry point.
 */
int main(void)
{
    InitializeSystem();

    #if defined(USB_INTERRUPT)
        USBDeviceAttach();
    #endif

    while(1)
    {
        #if defined(USB_POLLING)
            USBDeviceTasks();
        #endif

        UpdateStatusDisplay();
        ProcessIO();

        if(!switch_1) {
            mLED_On();
        }

        if(!switch_2) {
            mLED_Off();
        }
    }
}

/**
 * ProcessIO
 */
static void ProcessIO(void)
{
    BYTE numBytesRead;

    if (USBDeviceState < CONFIGURED_STATE || USBSuspendControl == 1) return;

    if (!HIDTxHandleBusy(lastTransmission))
    {
        joystick_input.members.buttons.one = !switch_1;
        joystick_input.members.buttons.two = !switch_2;
        
        lastTransmission = HIDTxPacket(HID_EP, (BYTE*)&joystick_input, sizeof(joystick_input));
    }

    if (mUSBUSARTIsTxTrfReady()) {
        numBytesRead = getsUSBUSART(USB_Out_Buffer, 64);
        if (numBytesRead > 0) {
            if (strcmp("on", USB_Out_Buffer) == 0) {
                putrsUSBUSART("Turning On\r\n");
                mLED_On();
            } else if (strcmp("off", USB_Out_Buffer) == 0) {
                putrsUSBUSART("Turning Off\r\n");
                mLED_Off();
            }

            unsigned char i;
            for (i = 0; i < sizeof(USB_Out_Buffer); i++) {
                USB_Out_Buffer[i] = 0;
            }
        }
    }

    CDCTxService();
}

/**
 * UpdateStatusDisplay
 */
void UpdateStatusDisplay(void)
{
    return;
    
    if (USBDeviceState == CONFIGURED_STATE)
    {
        mLED_On();
    }
}

#endif
